#pragma once

#include "../base/EntitySnapshotBase.h"

#include "EntityInstance.h"

#include "../workingmemory/EntitySnapshot.h"


namespace armarx::armem::ltm
{

    /**
     * @brief Data of an entity at one point in time.
     */
    class EntitySnapshot :
        public base::EntitySnapshotBase<EntityInstance, EntitySnapshot>
    {
        using Base = base::EntitySnapshotBase<EntityInstance, EntitySnapshot>;

    public:

        using Base::EntitySnapshotBase;
        using Base::operator=;


        // Conversion
        wm::EntitySnapshot convert(const aron::typenavigator::NavigatorPtr& = nullptr) const;

        // MongoDB connection
        void reload();
        void setTo(const wm::EntitySnapshot&, const armem::Time& t);

    protected:
        virtual void _copySelf(EntitySnapshot& other) const override
        {
            Base::_copySelf(other);
            other.dbsettings = dbsettings;
        }

        virtual void _copySelfEmpty(EntitySnapshot& other) const override
        {
            Base::_copySelfEmpty(other);
            other.dbsettings = dbsettings;
        }

    public:
        MongoDBConnectionManager::MongoDBSettings dbsettings;
    };
}
