#pragma once

#include "../base/CoreSegmentBase.h"

#include "ProviderSegment.h"
#include "detail/CopyWithoutData.h"


namespace armarx::armem::wm
{

    /**
     * @brief Data of a core segment containing multiple provider segments.
     */
    class CoreSegment :
        public base::CoreSegmentBase<ProviderSegment, CoreSegment>,
        public detail::CopyWithoutData<CoreSegment>
    {
        using Base = base::CoreSegmentBase<ProviderSegment, CoreSegment>;

    public:

        using Base::CoreSegmentBase;

        CoreSegment(const CoreSegment& other) = default;
        CoreSegment(CoreSegment&& other) = default;
        CoreSegment& operator=(const CoreSegment& other) = default;
        CoreSegment& operator=(CoreSegment&& other) = default;

        /**
         * @brief Convert the content of this segmnet into a commit
         * @return The resulting commit
         */
        Commit toCommit() const;

    protected:

        virtual void _copySelfWithoutData(CoreSegment& other) const override;

    };

}
