#pragma once

#include "BaseQueryProcessor.h"
#include "../base/MemoryQueryProcessorBase.h"

#include "CoreSegmentQueryProcessor.h"

namespace armarx::armem::wm::query_proc
{
    /**
     * @brief Handles memory queries.
     */
    class MemoryQueryProcessor :
        virtual public BaseQueryProcessor<wm::Memory, armem::query::data::MemoryQuery>,
        virtual public base::query_proc::MemoryQueryProcessorBase<wm::Memory>
    {
        using Base = BaseQueryProcessor<wm::Memory, armem::query::data::MemoryQuery>;

    public:
        MemoryQueryProcessor(DataMode dataMode = DataMode::WithData) :
            Base(dataMode), coreSegmentProcessor(dataMode)
        {}

    protected:
        virtual CoreSegmentT coreSegmentProcessorProcess(const armem::query::data::CoreSegmentQuerySeq& q, const CoreSegmentT& s) const override
        {
            return coreSegmentProcessor.process(q, s);
        }


    private:
        CoreSegmentQueryProcessor coreSegmentProcessor;
    };
}
